/*----- PROTECTED REGION ID(MagnetTypeStateMachine.cpp) ENABLED START -----*/
//=============================================================================
//
// file :        MagnetTypeStateMachine.cpp
//
// description : State machine file for the MagnetType class
//
// project :     MagnetTypePS
//
// This file is part of Tango device class.
// 
// Tango is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
// 
// Tango is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with Tango.  If not, see <http://www.gnu.org/licenses/>.
// 
//
// Copyright (C): 2004,2005,2006,2007,2008,2009,2009,2010,2011,2012,2013,2014,2015
//                European Synchrotron Radiation Facility
//                BP 220, Grenoble 38043
//                France
//
//=============================================================================
//                This file is generated by POGO
//        (Program Obviously used to Generate tango Object)
//=============================================================================

#include <MagnetType.h>

/*----- PROTECTED REGION END -----*/	//	MagnetType::MagnetTypeStateMachine.cpp

//================================================================
//  States   |  Description
//================================================================
//  ON       |  
//  OFF      |  
//  ALARM    |  
//  FAULT    |  
//  UNKNOWN  |  


namespace MagnetType_ns
{
//=================================================
//		Attributes Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_DesignStrengthFile_allowed()
 *	Description: Execution allowed for DesignStrengthFile attribute
 */
//--------------------------------------------------------
bool MagnetType::is_DesignStrengthFile_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(MagnetType::DesignStrengthFileStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	MagnetType::DesignStrengthFileStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for DesignStrengthFile attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::DesignStrengthFileStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	MagnetType::DesignStrengthFileStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_CorrectionStrengthsSteps_allowed()
 *	Description: Execution allowed for CorrectionStrengthsSteps attribute
 */
//--------------------------------------------------------
bool MagnetType::is_CorrectionStrengthsSteps_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for CorrectionStrengthsSteps attribute in Write access.
	/*----- PROTECTED REGION ID(MagnetType::CorrectionStrengthsStepsStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MagnetType::CorrectionStrengthsStepsStateAllowed_WRITE

	//	Not any excluded states for CorrectionStrengthsSteps attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::CorrectionStrengthsStepsStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MagnetType::CorrectionStrengthsStepsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_Strengths_allowed()
 *	Description: Execution allowed for Strengths attribute
 */
//--------------------------------------------------------
bool MagnetType::is_Strengths_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for Strengths attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::StrengthsStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	MagnetType::StrengthsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_StrengthsMSMM_allowed()
 *	Description: Execution allowed for StrengthsMSMM attribute
 */
//--------------------------------------------------------
bool MagnetType::is_StrengthsMSMM_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for StrengthsMSMM attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::StrengthsMSMMStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MagnetType::StrengthsMSMMStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_StrengthsReadPoint_allowed()
 *	Description: Execution allowed for StrengthsReadPoint attribute
 */
//--------------------------------------------------------
bool MagnetType::is_StrengthsReadPoint_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for StrengthsReadPoint attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::StrengthsReadPointStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	MagnetType::StrengthsReadPointStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_TotalCorrectionStrengths_allowed()
 *	Description: Execution allowed for TotalCorrectionStrengths attribute
 */
//--------------------------------------------------------
bool MagnetType::is_TotalCorrectionStrengths_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TotalCorrectionStrengths attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::TotalCorrectionStrengthsStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	MagnetType::TotalCorrectionStrengthsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_TotalCorrectionStrengthsMSMM_allowed()
 *	Description: Execution allowed for TotalCorrectionStrengthsMSMM attribute
 */
//--------------------------------------------------------
bool MagnetType::is_TotalCorrectionStrengthsMSMM_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for TotalCorrectionStrengthsMSMM attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::TotalCorrectionStrengthsMSMMStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MagnetType::TotalCorrectionStrengthsMSMMStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_CorrectionStrengths_allowed()
 *	Description: Execution allowed for CorrectionStrengths attribute
 */
//--------------------------------------------------------
bool MagnetType::is_CorrectionStrengths_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(MagnetType::CorrectionStrengthsStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	MagnetType::CorrectionStrengthsStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for CorrectionStrengths attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::CorrectionStrengthsStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	MagnetType::CorrectionStrengthsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_CorrectionStrengthsMSMM_allowed()
 *	Description: Execution allowed for CorrectionStrengthsMSMM attribute
 */
//--------------------------------------------------------
bool MagnetType::is_CorrectionStrengthsMSMM_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for CorrectionStrengthsMSMM attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::CorrectionStrengthsMSMMStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MagnetType::CorrectionStrengthsMSMMStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_ResonanceStrengths_allowed()
 *	Description: Execution allowed for ResonanceStrengths attribute
 */
//--------------------------------------------------------
bool MagnetType::is_ResonanceStrengths_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Check access type.
	if ( type!=Tango::READ_REQ )
	{
		//	Compare device state with not allowed states for WRITE
		if (get_state()==Tango::FAULT ||
			get_state()==Tango::UNKNOWN)
		{
		/*----- PROTECTED REGION ID(MagnetType::ResonanceStrengthsStateAllowed_WRITE) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	MagnetType::ResonanceStrengthsStateAllowed_WRITE
			return false;
		}
		return true;
	}
	else

	//	Not any excluded states for ResonanceStrengths attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::ResonanceStrengthsStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	MagnetType::ResonanceStrengthsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_ResonanceStrengthsMSMM_allowed()
 *	Description: Execution allowed for ResonanceStrengthsMSMM attribute
 */
//--------------------------------------------------------
bool MagnetType::is_ResonanceStrengthsMSMM_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for ResonanceStrengthsMSMM attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::ResonanceStrengthsMSMMStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MagnetType::ResonanceStrengthsMSMMStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_MagnetNames_allowed()
 *	Description: Execution allowed for MagnetNames attribute
 */
//--------------------------------------------------------
bool MagnetType::is_MagnetNames_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for MagnetNames attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::MagnetNamesStateAllowed_READ) ENABLED START -----*/
		
		/*----- PROTECTED REGION END -----*/	//	MagnetType::MagnetNamesStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_MagnetStates_allowed()
 *	Description: Execution allowed for MagnetStates attribute
 */
//--------------------------------------------------------
bool MagnetType::is_MagnetStates_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for MagnetStates attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::MagnetStatesStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MagnetType::MagnetStatesStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_RequireCycling_allowed()
 *	Description: Execution allowed for RequireCycling attribute
 */
//--------------------------------------------------------
bool MagnetType::is_RequireCycling_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for RequireCycling attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::RequireCyclingStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MagnetType::RequireCyclingStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_FrozenMagnets_allowed()
 *	Description: Execution allowed for FrozenMagnets attribute
 */
//--------------------------------------------------------
bool MagnetType::is_FrozenMagnets_allowed(TANGO_UNUSED(Tango::AttReqType type))
{

	//	Not any excluded states for FrozenMagnets attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::FrozenMagnetsStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MagnetType::FrozenMagnetsStateAllowed_READ
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_IsFrozen_allowed()
 *	Description: Execution allowed for IsFrozen attribute
 */
//--------------------------------------------------------
bool MagnetType::is_IsFrozen_allowed(TANGO_UNUSED(Tango::AttReqType type))
{
	//	Not any excluded states for IsFrozen attribute in Write access.
	/*----- PROTECTED REGION ID(MagnetType::IsFrozenStateAllowed_WRITE) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MagnetType::IsFrozenStateAllowed_WRITE

	//	Not any excluded states for IsFrozen attribute in read access.
	/*----- PROTECTED REGION ID(MagnetType::IsFrozenStateAllowed_READ) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MagnetType::IsFrozenStateAllowed_READ
	return true;
}


//=================================================
//		Commands Allowed Methods
//=================================================

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_Reset_allowed()
 *	Description: Execution allowed for Reset attribute
 */
//--------------------------------------------------------
bool MagnetType::is_Reset_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for Reset command.
	/*----- PROTECTED REGION ID(MagnetType::ResetStateAllowed) ENABLED START -----*/

	/*----- PROTECTED REGION END -----*/	//	MagnetType::ResetStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_ResetResonanceStrengths_allowed()
 *	Description: Execution allowed for ResetResonanceStrengths attribute
 */
//--------------------------------------------------------
bool MagnetType::is_ResetResonanceStrengths_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for ResetResonanceStrengths command.
	/*----- PROTECTED REGION ID(MagnetType::ResetResonanceStrengthsStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MagnetType::ResetResonanceStrengthsStateAllowed
	return true;
}

//--------------------------------------------------------
/**
 *	Method     : MagnetType::is_SetpointCheck_allowed()
 *	Description: Execution allowed for SetpointCheck attribute
 */
//--------------------------------------------------------
bool MagnetType::is_SetpointCheck_allowed(TANGO_UNUSED(const CORBA::Any &any))
{
	//	Not any excluded states for SetpointCheck command.
	/*----- PROTECTED REGION ID(MagnetType::SetpointCheckStateAllowed) ENABLED START -----*/
	
	/*----- PROTECTED REGION END -----*/	//	MagnetType::SetpointCheckStateAllowed
	return true;
}


/*----- PROTECTED REGION ID(MagnetType::MagnetTypeStateAllowed.AdditionalMethods) ENABLED START -----*/

//	Additional Methods

/*----- PROTECTED REGION END -----*/	//	MagnetType::MagnetTypeStateAllowed.AdditionalMethods

}	//	End of namespace
